20.05.2000 - First public version 1.0 released.
29.05.2000 - v.1.1
            Added new .INI-key "DebugMode" and "Language"
            Maked "GM.MSG" - base of the messages.
            Maked some little fixs.
6.06.2000  - v.1.2
            Added SpaceGuard (.INI-key "AlertMaxHDDFree", "AlertMinHDDFree" and "AlertAction")
            Removed ~CUR_DIR_NAME~
            Added variables:
                  ~SRC_FULL_DIR_NAME~,   ~SRC_FULL_DIR_NAME_W~
                  ~SRC_MIDDLE_DIR_NAME~, ~SRC_MIDDLE_DIR_NAME_W~
                  ~SRC_SHORT_DIR_NAME~,  ~SRC_SHORT_DIR_NAME_W~
                  ~DST_FULL_DIR_NAME~,   ~DST_FULL_DIR_NAME_W~
                  ~DST_MIDDLE_DIR_NAME~, ~DST_MIDDLE_DIR_NAME_W~
                  ~DST_SHORT_DIR_NAME~,  ~DST_SHORT_DIR_NAME_W~
            Added new .INI-key "SchemaSort=5" and "SchemaSort=6".
            Added new .INI-key "ClearDst"
            Added new .INI-key "DstFileCase", "DstDirsCase"
            Fully Win1251 codepage support.
            Fully "Russian" files name support.
            Fully Linux share support.
            Big internal changes.
17.06.2000 - v.1.3
            Self-correction "SrcDir" and "DstDir"
            Some changes in ~SRC_FULL_DIR_NAME_W~ and ~DST_FULL_DIR_NAME_W~
            Added new variables ~REL_PATH~ and ~REL_PATH_W~
            Instead of variables ~IMAGE_NAME_S~, ~IMAGE_NAME_L~, ~IMAGE_NAME_SW~, ~IMAGE_NAME_LW~
             added variables:
              ~SRC_IMAGE_NAME_S~, ~SRC_IMAGE_NAME_L~, ~SRC_IMAGE_NAME_SW~, ~SRC_IMAGE_NAME_LW~,
              ~DST_IMAGE_NAME_S~, ~DST_IMAGE_NAME_L~, ~DST_IMAGE_NAME_SW~, ~DST_IMAGE_NAME_LW~ 
            Added new .INI-key "RestoreSrcImageDate"
            Renamed "CopyOriginalImages" to "CopySrcImages"
            Renamed "UseOriginalIfSmall" to "UseSrcImageIfSmall"
            Reviewed algorithm of loading .INI files.
            Added new .INI-keys: "AutoIncrementAStart" - "AutoIncrementEStart"
             and new variables: ~AutoIncrementA~ - ~AutoIncrementE~
            More small errors was fixed.
30.06.2000 - v.1.4
            Maked "Index Page" (added into .INI-file section [Index] 
              and .INI-keys "CreateIndex", "IndexFileName",
              "IndexHeaderCode", "IndexRecordCode", "IndexFooterCode")
            Rename all olds *Home* variables to *Begin*
            Added new .INI-key "BtnNavHome"
            More changes in gm.htm
            Maked some little fixs.
20.07.2000 - v.1.5
            Renamed "HTMLFilePostfix" to "HTMLFileSuffix"
            Added new .INI-key "HTMLFilePostfix"
            Small change in "HTMLFileExt" 
            Added RenameWizard (.INI-keys:
              "ImageNameSchema", "ImagePrefix", "ImageSuffix", "ImagePostfix"
              "ThumbNameSchema", "ThumbPrefix", "ThumbSuffix", "ThumbPostfix" )
            Win2000 compatible .
25.07.2000 - v.1.6
            Added new .INI-keys: "EmptyCellCode" and "AddEmptyCellCodeIf1Row"
            Fixed small error in "FadeEllipseBevel" effect.
16.10.2000 - v.2.0
            Fundamental internal changes inside GM.EXE 
            Fully updated documentation
            !!! RUSSIAN documentation - /Doc/GM_Rus.htm
            !!! "Image Shell" available now! See documentation for details.
            Renamed sections
                    [System]     to [Global]
                    [HTML]       to [TablePage]
                    [Navigation] to [TableNavigation]
                    [Index]      to [IndexPage]
            Old section [Image] is split on [Image] and [Thumbnail]
            Move all "AutoIncrement"-keys into [Auto] 
            Removed "DebugMode" key
            Warning: Many .INI-keys and variables was renamed!
            Added new .INI-keys "SrcImageNameMask"
                                "SrcImageAttribute"
                                "AddEmptyCellCode"
                                and many other...
            Auto-correcting a value of "MainIndexPageFileName"
            Auto-create DstDir
            Statistics of 'Errors' and 'Warnings'
            The summary table "area of action" for all variables
            Work become more stable.
            Fixed some little bugs.
21.10.2000 - v.2.1
            Added "ProgressBar"
            Added new .INI-key "ColorInterface"
            Output to the console is optimized 
            Added new statistic: "messages"
            Fixed error appearing sometimes at opening of file from network drive.
            Fixed small error in .INI key 'Language'.
            Fixed small error in .INI key 'AddEmptyCellCodeIf1Row'.
            Fixed error in variable ~TOTAL_IMAGES_SIZE_?~.
17.11.2000 - v.2.2
            Rename variable ~SYSTEM_DATE~ to ~CURRENT_SYSTEM_DATE~
            Rename variable ~SYSTEM_TIME~ to ~CURRENT_SYSTEM_TIME~
            Added new variables:
                ~CURRENT_DAY_VALUE~,
                ~CURRENT_MONTH_VALUE~,
                ~CURRENT_YEAR_VALUE~,
                ~CURRENT_HOUR_VALUE~,
                ~CURRENT_MINUTE_VALUE~,
                ~CURRENT_SECOND_VALUE~,
                ~CURRENT_DAYOFWEEK_NAME_LONG~,
                ~CURRENT_DAYOFWEEK_NAME_SHORT~,
                ~CURRENT_MONTH_NAME_LONG~,
                ~CURRENT_MONTH_NAME_SHORT~,
                ~CURRENT_UTC_DATE~',
                ~CURRENT_UTC_TIME~',
                ~CURRENT_INTERNET_DATE~,
                ~CURRENT_INTERNET_TIME~
            Next variables:
                ~TABLE_BEGIN_PAGE~,
                ~TABLE_PREV_PAGE~,
                ~MAIN_INDEX_PAGE~,
                ~TABLE_NEXT_PAGE~,
                ~TABLE_END_PAGE~ moved into "TCF_TNI" group
                 (now you can make slideshow of images).
            Moved all variables from "SNI" group into "SCF_SNI" group.
            New .INI-key: "UDVNameCaseIgnore"
            New .INI-key: "UDVNameCodePage"
            New .INI-key: "RoundBtnNavigation"
            New high speed Boyer-Moore search algorithm.
            Now you can use UserDef-variables inside other UserDef-variables.
            New graphical formats are supported: PNG, GFI, SGI Wavefront, Paintshop Pro
25.12.2000 - v.2.3     
            The work on creation of the plugin-interface is begun.
            Changed algorithm of connecting new language modules.
            New .INI-key: "JPEGProgressiveEncoding" and "JPEGGrayscale"
            New .INI-key: "ImagesListName"
            New 'SchemaSort' mode "7"
            New funny utils - "ILM.exe" and "CRC32.exe"
25.01.2001 - v.2.4 
            More internal changes inside 'ILM.exe':
             + Dynamic change the size of ThumbWindow
             + New file formats supported
             + new .INI-keys: "ThumbWidth" and "ThumbHeight"
            New algorithm of calculation CRC-32 in "CRC32.exe"
            !!! Internal CSV generator !!! See documentation for details.
            Added new variables: ~SRC_IMAGE_CRC32~, ~SRC_IMAGE_BPP~
            GM graphic subsystem is fully reviewed.
            New resampling filters (.INI-key: "ThumbResamplingFilter").
            Optimized quality of "FadeRectangleBevel" and "FadeEllipseBevel" effects.
            New graphical formats are supported: WMF, EMF, ICO, EPS
            New .INI-key: "ThumbFormat"
            .INI-key "MainIndexPageRecordCode" moved into [IndexPage] section
            Group "IPI" expanded to "TCF_SCF_IRC_TNI_SNI_IPI"
            Moved and renamed (for convenience of work) some variables.
            Deleted vars: ~PAGES~, ~IMAGES~, ~SIZE_B~, ~SIZE_K~, ~SIZE_M~
            Fixed small errors in source code and documentation.
            All .exe are compiled on Delphi 4.
11.03.2001 - v.2.5
            In this version I has added only one new function - "ThumbFrame".
            I made the large work for this purpose - fully modernize "ILM.exe".
            Look at main documentation and "/Doc/ILM.txt" for details.
            "Dutch" language module for GM
            Also has corrected some small bugs.
25.04.2001 - v.2.6
            Support the unlimited size of file for CRC32 calculation (CRC32.exe and GM.exe)
             + Support "FileMask" in command line CRC32.exe
            Improved modification ILM.exe:
             + Multi-language support
             + Comment-files support
             + Auto-generation the optimal "ThumbFrame"
             + Two new type of sort
             + External process support
             + Optimized some fragments of code
             + Fixed some little bugs, added new :)
            Some changes for GM.exe
             + New .INI-key: "SrcImageDateMask"
             + New .INI-key: "SrcImageSizeMask"
             + Renamed "SrcImageAttribute" to "SrcImageAttributeMask"
             + New 'SchemaSort' mode "8" and "9"
             + Processing Ctrl-C/Ctrl-Break and Shutdown/Logoff (WinNT/2000 only) signals
             + Optimized some fragments of code
15 May 2001 - v.2.7
            Improved modification ILM.exe:
             + New cool "ThumbFrame" rectangle
             + Fixed some little bugs
            New .INI-key: "AutoRemoveDisabledButtons"
            Fully reviewed "navigation"-subsystem
            Section [IndexPage] renamed to [MainIndexPage]
            Renamed: "CreateMainIndexPage" to "CreateMainIndex"
                     "BtnNavIndex" to "BtnNavMainIndex"
                     and some others variables ...
            !!! Fundamental changes: "LocalIndexPage" available now!
                See documentation for details
            Fully reviewed documentation
            Corrected all examples
            New homepage http://levelbbs.chat.ru/ (враги сожгли родную хаатуу...)
18 Jun 2001 - v.2.8 
            ! No functional changes - only small internal fixs
            ! At present time I develop new engine for GM
            + Improved algorithm for determination Windows version 
            + Small fix for more exact detection total/free disc space on large HDD
            * I has detect that some ZIP-archivers incorrect extract blank
              subdirectories from lvlhgm*.zip, because I have removed the
              directory "Plugins" from archive and .ini-key "PluginsDir"
30 Jul 2001 
            GM v.2.9:
              + New algorithm for dynamic creation the destination directories.
              + Added two new variables:
                  ~GM_FULL_DIR_NAME~
                  ~GM_FULL_DIR_NAME_W~
              + Reviewed/Optimized some fragments of code
              + Speed of work is increased

            ILM v.1.4:
              + New cursor mode - "Magnifying Glass" (look at "Misc"-bookmark)
                Hint: click on right mouse button inside "Thumb"-window
              + New "Create new ..." dialog (for case if ImagesList already exists)
              + New "Save as ..." dialog
              + New cool "Font"-list (look at "Fonts & colors"-bookmark)
              + Fixed small errors
22 Aug 2001 
            GM v.3.0:
              + Optimized FX2_Shadow (you can change shadow direction now)
              + New F/X: FX6_FadeShadow, FX7_Film, FX8_Stamp
              + Fixed very small bug for FX5_FadeEllipseBevel
              + New feature - Read/Write the comments inside JPG-files.
              + !!! LoadFromFile("FileName") expression !!!
              + New .INI-key "IncriminateNNCount" and variable ~TOTAL_NN~
              + New .INI-key "BlurBorder" (for FX7_Film, FX8_Stamp)

18 Oct 2001 
            New cool utility - "JPEGComment Editor" (see /Doc/JCE.txt for details)
            Improved version of "CRC32.exe" (subdirectory support)
            ILM v.1.41:
              + Changed format of .INI-key "Language"
              + Very small internal changes and fixs
            GM v.3.1:
              + New .INI-keys: "CodePageFileName", "PostProcess"
              + Removed .INI-keys: "UDVNameCodePage", "UDVNameCaseIgnore"
              + Renamed .INI-key "UserJpegComText" to "JPEGComment"
              + Removed .INI-key "CopySrcJpegComToThumb",
                instead of this, added new variable: ~SRC_JPEG_COMMENT~
              + New special expressions: "SearchAndReplace", "UpperCase",
                "LowerCase", "RecodeText", "SaveToFile"
              + Improved "FX2_Shadow" - .INI-key "Radius" (for rounded corners)
              + Added new variable: ~THUMB_NAME_W~ 
              + Changed format of .INI-key "Language" - Be careful!
              + Expanded the format of .INI-keys "ThumbHeight" and "ThumbWidth"
                and algorithm of its work
              + From http://www.lict.ru/gallery/ you can download
                latest version of GM with visual shell!
                Say "Great thanks!" to our friends from N.Novgorod.
11 Dec 2001 
            GM v.3.2:
              + Fixed bug for mode "CommentRecode=No"
              + Fixed bug inside Win-1251 code-table
            ILM v.1.5:
              + optimized code and interface
              + Fixed some small bugs
            JCE v.1.1:
              + optimized code and interface
              + Fixed some small bugs
            Now I start write new greate tool - "Image processor" - will be cool ;)
04 March 2002
            + New util - "Localizator v.1.1" (read "/Language/ReadMe.txt")
            + Renamed "CodePage.ini" -> "CodePage.tbl"
            + Renamed "gm.ini" -> "gm.gmp"
            ILM v.1.6:
              + Rename section name [General] -> [Settings]
              + new fast LogConsole
              + optimized source code
              + fixed some small bugs
            GM v.3.3:
              + Lots of changes
                + Now GM has two parts: GM-Shell - "gm.exe"
                  and GM-Kernel - "gm.dll". I have stopped using standard
                  windows console and integrated my own LogConsole inside GM-Shell.
                + improved structure of a log-file
                + changed format for .INI-key "ClearDst"
                + New .INI-key "DeleteToRecycleBin"
                + New .INI-key for GM-Shell (gm.ini)
                + deleted .INI-key "ColorInterface"
                + renamed .INI-key "LocalINIFileName" -> "LocalGMPFileName"
                + fully reviewed and optimized source code
              + optimized structure of language modules,
                added the new module - "German.lng"

            And one more important change: "IMAGE PROCESSOR" (IP v.0.6)
            is now available as a standalone module.
            This is the first version, but it really works.
            Only russian "\Doc\IP.txt" available now, no any other docs, 
            Simple run "ip.exe" and you will see how it works.

19 June 2002
          Main news - "GM" and "IP" fully integrated now! You can call any
          IP-"scenario" from your GM-project both for image and for thumbnail.
          All language modules loaded directly from shells (GM and IP)
          so all messages from kernels (GM and IP) has been completely localized now.
          
          Some other news:
            IP v.0.8
              + new task "CopyFile"
              + added mode "Custom 'ThumbFrame'" for task "ResizeCanvas"
              + task "SaveToFile" improved and expanded 
              + new efficient cache-subsystem for images and scenarios
              + begin supports of language modules
              + many internal changes and fixs
            GM v.3.5:
              + Deleted all graphic function. Size of "gm.dll" is only 230kb
              + Deleted from ".gmp" and moved to ".ips" next keys :
                "CopySrcImagesToDst", "RestoreSrcImageDate", "CreateThumbs",
                "ThumbFormat", "ThumbResamplingFilter", "ThumbWidth", "ThumbHeight"
                "UseSrcImageIfSmall", "JPEGCompressionQuality", "JPEGProgressiveEncoding",
                "JPEGGrayscale", "JPEGComment", "BorderSchema", "BlurBorder"
                "Shadow_X", "Shadow_Y", "Radius", "Shadow_Color", "BG_Color", "FG_Color",
                "FG_Line1Thickness", "FG_Line2Thickness", "BG_Line1Thickness",
                "BG_Line2Thickness", "FG_Line1Color", "FG_Line2Color", "BG_Line1Color",
                "BG_Line2Color", "Top_Amount", "Left_Amount", "Right_Amount",
                "Bottom_Amount", "Bevel_Thickness", "SharpenRadius", "SharpenLevel"
              + Added the next important keys to ".gmp": 
                "ThumbImageScenario", "ShellImageScenario"
              + Renamed some keys and variables, more changes...
              + Reviewed docs and samples
            LOC v.1.2
              + new features...

22 August 2002
            GM v.3.6 beta 1:
              + Now and forever - no single HTML-fragments,
                all of them are collected inside four HTML-templates: 
                "Table", "Shell", "MainIndex" and "LocalIndex".
                Some superfluous HTML-fragments and .INI-keys are removed.
                Now is very easy to create templates for your own galleries.
              + New "Upon completion" options
              + Correct receiving and processing the signals "Shutdown computer" and "User logoff".
              + Increase of speed ~10-15%
              + Updated docs and samples
